<?xml version="1.0"?>

<st-source>
<!-- Changes in change set 2008-02-22-TSA-issue -->
<time-stamp>From VisualWorks®, 7.4.1 of May 30, 2006 on February 22, 2008 at 11:36:56 pm</time-stamp>


<methods>
<class-id>PROVISO.StreamOperator</class-id> <category>operator graph</category>

<body package="PV-Streams-Support" selector="root">root
	
	| last current |
	current := self.
	last := self.
	[current isNil] 
		whileFalse: 
			[last := current.
			current := current parent].
	^last</body>
</methods>

<methods>
<class-id>PROVISO.StreamOperator</class-id> <category>processing</category>

<body package="NGUBA-Application" selector="executeWithWriteControl:">executeWithWriteControl: aBlock 

	^aBlock value</body>
</methods>


<reorganize>
<class-id>PROVISO.StreamOperator</class-id> <organization>('period policy callbacks' #emitEndOfPeriodFor: #emitHeartbeatFor: #onEndOfPeriod: #onStartOfPeriod:)
('accessing' #addClient: #addNonTemporalSource: #addSource: #client #clients #clients: #connectAsSourceTo: #connectAsSourceTo:asynchronously: #connectPushPullClient: #connectPushPushClient: #connectTupleSink #defaultName #handler #handler: #name #name: #source #sources #sources: #timeoutPeriod #timeoutPeriod: #trueClients #trueClientSatisfying: #trueSources #trueSourceSatisfying:)
('visiting' #acceptVisit:)
('control' #handleHeartbeatForTimestamp: #initializeForRuntime #start #stop)
('testing' #isProducingTuples #isTemporal #isTemporalJoin)
('printing' #printOn:)
('user interface' #emphasisForTreeViewClosed)
('api-new' #smeeProduce:)
('transactions' #commandLogClass #newCommandLog #transactionDo:)
('operator graph' #allOperators #earliestPeriod #egressOperators #ingressOperators #isPredecessorOf: #isSuccessorOf: #latestPeriodOfAllDescendants #root)
('logging' #logEndOfPeriod #logStartOfPeriod)
('timeout' #checkForTimeout #startCronJobForTimeout #stopCronJobForTimeout #timeoutCronJobName #timeoutResolution)
('accessing configuration' #recomputationLabel)
('initialize-release' #initialize)
('icons')
('state recovery' #langolierOlderThan:)
('processing' #discardObsoleteTuple: #doHandleTuple: #executeWithWriteControl: #forceEndOfCurrentPeriod #forceNextPeriod #handleHeartbeat: #handleNormalTuple: #handleTuple: #produce:)
</organization>
</reorganize>

<methods>
<class-id>PROVISO.UBA.UBAOperator</class-id> <category>processing</category>

<body package="NGUBA-Application" selector="executeWithWriteControl:">executeWithWriteControl: aBlock 
	
	^self root modelProprietor
		ifNil: [aBlock value]
		ifNotNil: [:instance | instance executeWithWriteControl: aBlock]</body>
</methods>

<methods>
<class-id>PROVISO.UBA.UBAOperator</class-id> <category>control</category>

<body package="NGUBA-Application" selector="handleNormalTuple:">handleNormalTuple: aTuple 
	
	self pvNamespace currentTimestamp: aTuple timestamp.
	self root executeWithWriteControl: 
		[self periodPolicy establishAndSignalImplicitStartOfPeriodFor: aTuple timestamp.
		super handleNormalTuple: aTuple]</body>
</methods>


<methods>
<class-id>PROVISO.UBA.BaseTemporalJoin</class-id> <category>processing</category>

<body package="NGUBA-Application" selector="processBufferedTuplesWhilePossible">processBufferedTuplesWhilePossible
	
	self root executeWithWriteControl: 
		[self periodPolicy processBufferedTuplesWhilePossible]</body>
</methods>



</st-source>
